"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserNoticeCompounds = exports.PrivateMessageCompounds = exports.NoticeCompounds = exports.ChatReadyStates = void 0;
var twitch_1 = require("../twitch");
var ChatReadyStates;
(function (ChatReadyStates) {
    ChatReadyStates[ChatReadyStates["WAITING"] = 0] = "WAITING";
    ChatReadyStates[ChatReadyStates["CONNECTING"] = 1] = "CONNECTING";
    ChatReadyStates[ChatReadyStates["RECONNECTING"] = 2] = "RECONNECTING";
    ChatReadyStates[ChatReadyStates["CONNECTED"] = 3] = "CONNECTED";
    ChatReadyStates[ChatReadyStates["DISCONNECTING"] = 4] = "DISCONNECTING";
    ChatReadyStates[ChatReadyStates["DISCONNECTED"] = 5] = "DISCONNECTED";
})(ChatReadyStates = exports.ChatReadyStates || (exports.ChatReadyStates = {}));
var NoticeCompounds;
(function (NoticeCompounds) {
    NoticeCompounds["ALREADY_BANNED"] = "NOTICE/ALREADY_BANNED";
    NoticeCompounds["ALREADY_EMOTE_ONLY_OFF"] = "NOTICE/ALREADY_EMOTE_ONLY_OFF";
    NoticeCompounds["ALREADY_EMOTE_ONLY_ON"] = "NOTICE/ALREADY_EMOTE_ONLY_ON";
    NoticeCompounds["ALREADY_R9K_OFF"] = "NOTICE/ALREADY_R9K_OFF";
    NoticeCompounds["ALREADY_R9K_ON"] = "NOTICE/ALREADY_R9K_ON";
    NoticeCompounds["ALREADY_SUBS_OFF"] = "NOTICE/ALREADY_SUBS_OFF";
    NoticeCompounds["ALREADY_SUBS_ON"] = "NOTICE/ALREADY_SUBS_ON";
    NoticeCompounds["BAD_HOST_HOSTING"] = "NOTICE/BAD_HOST_HOSTING";
    NoticeCompounds["BAD_MOD_MOD"] = "NOTICE/BAD_MOD_MOD";
    NoticeCompounds["BAN_SUCCESS"] = "NOTICE/BAN_SUCCESS";
    NoticeCompounds["BAD_UNBAN_NO_BAN"] = "NOTICE/BAD_UNBAN_NO_BAN";
    NoticeCompounds["COLOR_CHANGED"] = "NOTICE/COLOR_CHANGED";
    NoticeCompounds["CMDS_AVAILABLE"] = "NOTICE/CMDS_AVAILABLE";
    NoticeCompounds["COMMERCIAL_SUCCESS"] = "NOTICE/COMMERCIAL_SUCCESS";
    NoticeCompounds["EMOTE_ONLY_OFF"] = "NOTICE/EMOTE_ONLY_OFF";
    NoticeCompounds["EMOTE_ONLY_ON"] = "NOTICE/EMOTE_ONLY_ON";
    NoticeCompounds["FOLLOWERS_OFF"] = "NOTICE/FOLLOWERS_OFF";
    NoticeCompounds["FOLLOWERS_ON"] = "NOTICE/FOLLOWERS_ON";
    NoticeCompounds["FOLLOWERS_ONZERO"] = "NOTICE/FOLLOWERS_ONZERO";
    NoticeCompounds["HOST_OFF"] = "NOTICE/HOST_OFF";
    NoticeCompounds["HOST_ON"] = "NOTICE/HOST_ON";
    NoticeCompounds["HOSTS_REMAINING"] = "NOTICE/HOSTS_REMAINING";
    NoticeCompounds["MSG_CHANNEL_SUSPENDED"] = "NOTICE/MSG_CHANNEL_SUSPENDED";
    NoticeCompounds["MOD_SUCCESS"] = "NOTICE/MOD_SUCCESS";
    NoticeCompounds["NOT_HOSTING"] = "NOTICE/NOT_HOSTING";
    NoticeCompounds["R9K_OFF"] = "NOTICE/R9K_OFF";
    NoticeCompounds["R9K_ON"] = "NOTICE/R9K_ON";
    NoticeCompounds["ROOM_MODS"] = "NOTICE/ROOM_MODS";
    NoticeCompounds["SLOW_OFF"] = "NOTICE/SLOW_OFF";
    NoticeCompounds["SLOW_ON"] = "NOTICE/SLOW_ON";
    NoticeCompounds["SUBS_OFF"] = "NOTICE/SUBS_OFF";
    NoticeCompounds["SUBS_ON"] = "NOTICE/SUBS_ON";
    NoticeCompounds["TIMEOUT_SUCCESS"] = "NOTICE/TIMEOUT_SUCCESS";
    NoticeCompounds["UNBAN_SUCCESS"] = "NOTICE/UNBAN_SUCCESS";
    NoticeCompounds["UNMOD_SUCCESS"] = "NOTICE/UNMOD_SUCCESS";
    NoticeCompounds["UNRAID_SUCCESS"] = "NOTICE/UNRAID_SUCCESS";
    NoticeCompounds["UNRECOGNIZED_CMD"] = "NOTICE/UNRECOGNIZED_CMD";
})(NoticeCompounds = exports.NoticeCompounds || (exports.NoticeCompounds = {}));
var PrivateMessageCompounds;
(function (PrivateMessageCompounds) {
    PrivateMessageCompounds["CHEER"] = "PRIVMSG/CHEER";
    PrivateMessageCompounds["HOSTED_WITHOUT_VIEWERS"] = "PRIVMSG/HOSTED_WITHOUT_VIEWERS";
    PrivateMessageCompounds["HOSTED_WITH_VIEWERS"] = "PRIVMSG/HOSTED_WITH_VIEWERS";
    PrivateMessageCompounds["HOSTED_AUTO"] = "PRIVMSG/HOSTED_AUTO";
})(PrivateMessageCompounds = exports.PrivateMessageCompounds || (exports.PrivateMessageCompounds = {}));
var UserNoticeCompounds;
(function (UserNoticeCompounds) {
    UserNoticeCompounds["ANON_GIFT_PAID_UPGRADE"] = "USERNOTICE/ANON_GIFT_PAID_UPGRADE";
    UserNoticeCompounds["GIFT_PAID_UPGRADE"] = "USERNOTICE/GIFT_PAID_UPGRADE";
    UserNoticeCompounds["RAID"] = "USERNOTICE/RAID";
    UserNoticeCompounds["RESUBSCRIPTION"] = "USERNOTICE/RESUBSCRIPTION";
    UserNoticeCompounds["RITUAL"] = "USERNOTICE/RITUAL";
    UserNoticeCompounds["SUBSCRIPTION"] = "USERNOTICE/SUBSCRIPTION";
    UserNoticeCompounds["SUBSCRIPTION_GIFT"] = "USERNOTICE/SUBSCRIPTION_GIFT";
    UserNoticeCompounds["SUBSCRIPTION_GIFT_COMMUNITY"] = "USERNOTICE/SUBSCRIPTION_GIFT_COMMUNITY";
})(UserNoticeCompounds = exports.UserNoticeCompounds || (exports.UserNoticeCompounds = {}));
//# sourceMappingURL=chat-types.js.map